--- automatische ballenladegabel
--- by acert - find me @ modhoster.de


autoBaleGrab = {};

function autoBaleGrab.prerequisitesPresent(specializations)
    return true
end;

function autoBaleGrab:load(xmlFile)

	
	
					
	self.ShowReadyHud = true
	self.ReadyToSearch = true
	self.changeBody = false

	
	--self.beepNode = autoBaleGrab.beepNode;
	self.bodyType = autoBaleGrab.bodyType;
	self.bodyTypeB = autoBaleGrab.bodyTypeB;
	self.bodyTypeC = autoBaleGrab.bodyTypeC;
	self.bodyTypeD = autoBaleGrab.bodyTypeD;
	self.searchBale = autoBaleGrab.searchBale					
	self.searchBaleB = autoBaleGrab.searchBaleB;
	self.bodyTypeInRange = autoBaleGrab.bodyTypeInRange;
	--self.beeperInRange = autoBaleGrab.beeperInRange;
	
	
	self.objectInRange = autoBaleGrab.objectInRange;

	--self.beepindexA = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.beepA#index"));
	--self.beepindexB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.beepB#index"));
	
	self.Search = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Search#index"));
	self.SearchB = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SearchB#index"));
	self.SearchC = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SearchC#index"));
	self.SearchD = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SearchD#index"));

	
	
	self.hudBaleStatusPosX = 0.86;
    self.hudBaleStatusWidth = 0.1;
    self.hudBaleStatusPosY = 0.16;
    self.hudBaleStatusHeight = 0.1;
	
	self.infoPanelBaleStatusONPath = Utils.getFilename("BaleStatus_symb_yes.png", self.baseDirectory);
	self.hudBaleStatusONOverlay = Overlay:new("BaleStatus_symb_yes", self.infoPanelBaleStatusONPath, self.hudBaleStatusPosX, self.hudBaleStatusPosY, self.hudBaleStatusWidth, self.hudBaleStatusHeight);
	self.infoPanelBaleStatusOFFPath = Utils.getFilename("BaleStatus_symb_no.png", self.baseDirectory);
	self.hudBaleStatusOFFOverlay = Overlay:new("BaleStatus_symb_no", self.infoPanelBaleStatusOFFPath, self.hudBaleStatusPosX, self.hudBaleStatusPosY, self.hudBaleStatusWidth, self.hudBaleStatusHeight);
	
	self.showhudBaleStatus = false;
	
	

end;		


function autoBaleGrab:delete()
	if self.hudBaleStatusONOverlay ~= nil or self.hudBaleStatusOFFOverlay ~= nil then
		self.hudBaleStatusONOverlay:delete();
		self.hudBaleStatusOFFOverlay:delete();		
	end;
	
	

end;


function autoBaleGrab:mouseEvent(posX, posY, isDown, isUp, button)
end;

function autoBaleGrab:keyEvent(unicode, sym, modifier, isDown)
end;

function autoBaleGrab:update(dt)
  if self:getIsActive() then
	self:bodyType()
	self:bodyTypeB()
	self:bodyTypeC()
	self:bodyTypeD()
--	self:beepNode()
	
	if self.gotBaleA == true or self.gotBaleB == true or self.gotBaleC == true or self.gotBaleD == true then
			
				if InputBinding.hasEvent(InputBinding.GRABOFF) then
					self.changeBody = true
					if self.changeBody == true then
						self.ReadyToSearch = false
						self.WaitForInp = true
					end	
				end;
				
	end;
	

		
		if self.ReadyToSearch == false then
			self.showhudBaleStatus = false;
			if InputBinding.hasEvent(InputBinding.GRAB) then
				self.ReadyToSearch = true
				self.WaitForInp = false
				self.ShowReadyHud = true
				self.changeBody = false
			end;
		end;
		
		if self.ReadyToSearch then
		
						self.changeBody = false
						self.showhudBaleStatus = true;
						self:searchBale()
						self:searchBaleB()	
		
		end;
		
		
		   
	
  end	
	
end;

function autoBaleGrab:updateTick(dt)	
end;
	


	
function autoBaleGrab:draw()
	
		if self.ReadyToSearch == true then
			self.hudBaleStatusONOverlay:render();
		else	
			self.hudBaleStatusOFFOverlay:render();
		end;
	
	

	
	if self.ShowReadyHud == true then
		g_currentMission:addExtraPrintText(g_i18n:getText("SHOWREADY"));
	end;	
	
	if self.WaitForInp then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("WAIT"), self.typeDesc), InputBinding.GRAB);
	end;
	
	if self.gotBaleA == true or self.gotBaleB == true or self.gotBaleC == true or self.gotBaleD == true then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BALERELEASE"), self.typeDesc), InputBinding.GRABOFF);
	end;
	
	
end;


function autoBaleGrab:objectInRange(refNode)
	local nearestDistance = 1;
    local nearestBale = nil;
    local px, py, pz = getWorldTranslation(refNode);
	for index, item in pairs(g_currentMission.itemsToSave) do
	    itemNode = item.item.nodeId;
	    if getParent(item.item.nodeId) == getRootNode() then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = index;
					nearestBale = item.item;
					nearestObject = itemNode;
					nearestDistance = distance;
				end;
		end;
	end;	
    return nearestBale;
end;

function autoBaleGrab:searchBale()
				local bale = self:objectInRange(self.Search);
				if bale ~= nil then
					
					baleId = networkGetObjectId(bale);
					bale = networkGetObject(baleId);
					
						if getUserAttribute(bale.nodeId, "isRoundbale") == true then
							if self.ReadyToSearch == true then
								self.gotBaleA = true
								self.ShowReadyHud = false
								local x,y,z = getWorldTranslation(self.SearchC);
								local rx,ry,rz = getWorldRotation(self.SearchC);
								setTranslation(bale.nodeId, x,y,z )
								setRotation(bale.nodeId, rx,ry,rz);	
								setRigidBodyType(bale.nodeId,"NoRigidBody");		
							end	
						else
							if self.ReadyToSearch == true then
								self.gotBaleA = true
								self.ShowReadyHud = false
								local x,y,z = getWorldTranslation(self.Search);
								local rx,ry,rz = getWorldRotation(self.Search);
								setTranslation(bale.nodeId, x,y,z )
								setRotation(bale.nodeId, rx,ry,rz);	
								setRigidBodyType(bale.nodeId,"NoRigidBody");		
							end	
						end	
					
				
				else		
					self.gotBaleA = false	
				end;
end;

------------------ trigger b ---------------


function autoBaleGrab:searchBaleB()
				local bale = self:objectInRange(self.SearchB);
				if bale ~= nil then
					
					baleId = networkGetObjectId(bale);
					bale = networkGetObject(baleId);
					if getUserAttribute(bale.nodeId, "isRoundbale") == true then
						if self.ReadyToSearch == true then
							self.gotBaleA = true
							self.ShowReadyHud = false
							local x,y,z = getWorldTranslation(self.SearchD);
							local rx,ry,rz = getWorldRotation(self.SearchD);
							setTranslation(bale.nodeId, x,y,z )
							setRotation(bale.nodeId, rx,ry,rz);
							setRigidBodyType(bale.nodeId,"NoRigidBody");	
						end		
					else
						if self.ReadyToSearch == true then
							self.gotBaleA = true
							self.ShowReadyHud = false
							local x,y,z = getWorldTranslation(self.SearchB);
							local rx,ry,rz = getWorldRotation(self.SearchB);
							setTranslation(bale.nodeId, x,y,z )
							setRotation(bale.nodeId, rx,ry,rz);
							setRigidBodyType(bale.nodeId,"NoRigidBody");	
						end	
					end
					
				else		
					self.gotBaleB = false	
				end;
end;




function autoBaleGrab:bodyTypeInRange(place,object)
	self.nearestDistance = 0.7;
	local x, y, z = getWorldTranslation(place);
	local bx, by, bz = getWorldTranslation(object);
	local distance = Utils.vector3Length(x-bx, y-by, z-bz);
	
	if distance < self.nearestDistance then
		return true
	else
		return false
	end
end;

function autoBaleGrab:bodyType()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale)  then
				local isInRange = self:bodyTypeInRange(self.Search, item.item.nodeId);			
				if isInRange == false then
					setRigidBodyType(item.item.nodeId,"Dynamic");
				end		
		end;
	end;
end;
function autoBaleGrab:bodyTypeB()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale)  then
				local isInRange = self:bodyTypeInRange(self.SearchB, item.item.nodeId);			
				if isInRange == false then
					setRigidBodyType(item.item.nodeId,"Dynamic");
				end		
		end;
	end;
end;
function autoBaleGrab:bodyTypeC()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale)  then
				local isInRange = self:bodyTypeInRange(self.SearchC, item.item.nodeId);			
				if isInRange == false then
					setRigidBodyType(item.item.nodeId,"Dynamic");
				end		
		end;
	end;
end;
function autoBaleGrab:bodyTypeD()
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale)  then
				local isInRange = self:bodyTypeInRange(self.SearchD, item.item.nodeId);			
				if isInRange == false then
					setRigidBodyType(item.item.nodeId,"Dynamic");
				end		
		end;
	end;
end;

-------------------------------------------------------------------------------------




------function autoBaleGrab:beeperInRange(place,object)
---	self.nearestDistance = 0.3;
	---local x, y, z = getWorldTranslation(place);
	--local bx, by, bz = getWorldTranslation(object);
	--local distance = Utils.vector3Length(x-bx, y-by, z-bz);
	
	--if distance < self.nearestDistance then
	--	return true
	--else
	--	return false
	--end
--end;

---function autoBaleGrab:beepNode()
	---for index,item in pairs(g_currentMission.itemsToSave) do
	---	if item.item:isa(Bale)  then
		--		local isInRangeA = self:beeperInRange(self.Search, item.item.nodeId);
		---		local isInRangeB = self:beeperInRange(self.Search, item.item.nodeId);
		--		if isInRangeA == true or isInRangeA == true then
--self.PlayBeep = true 
		--		end		
		--end;
	--end;
--end;